/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var StrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StrategyBasedIndicator, _super);
    function StrategyBasedIndicator() {
        var _this = _super.call(this) || this;
        _this.zc();
        return _this;
    }
    StrategyBasedIndicator.prototype.zc = function () {
        this.yx = this.yy;
        this.ab = this.zb;
    };
    StrategyBasedIndicator.prototype.y4 = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.zd = function (a) {
    };
    StrategyBasedIndicator.prototype.y6 = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.y3 = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.zh = function (a, b, c) {
        var d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, function (e, f) { return (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
        StrategyBasedIndicator.y1.add(c);
        return d;
    };
    StrategyBasedIndicator.zg = function (a, b) {
        return StrategyBasedIndicator.zh(a, b, "Period");
    };
    StrategyBasedIndicator.ze = function (a, b) {
        return StrategyBasedIndicator.zh(a, b, "LongPeriod");
    };
    StrategyBasedIndicator.zi = function (a, b) {
        return StrategyBasedIndicator.zh(a, b, "ShortPeriod");
    };
    StrategyBasedIndicator.prototype.ya = function (a, b) {
        var c = this.um(a, b);
        var d = this.un(c);
        return this.yx.b(c, d);
    };
    StrategyBasedIndicator.prototype.x7 = function (a, b) {
        var c = this.um(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.vi(this.ya(a, b))) {
            return false;
        }
        var d = this.un(c);
        if (this.x3 != null) {
            c.minimumValue = this.x3.c;
            c.maximumValue = this.x3.b;
        }
        var e = this.yx.a(c, d);
        for (var f = 0; f < this.yc && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.uv != null && this.y0(c)) {
            this.uv.c1();
        }
        return e;
    };
    StrategyBasedIndicator.prototype.y0 = function (a) {
        var e_1, _a;
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            var b = this.x3;
            this.x3 = new AxisRange(a.minimumValue, a.maximumValue);
            return this.yz(b, this.x3);
        }
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(a.indicatorColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        var f = this.x3;
        this.x3 = new AxisRange(c, d);
        return this.yz(f, this.x3);
    };
    StrategyBasedIndicator.prototype.yz = function (a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    };
    StrategyBasedIndicator.prototype.y5 = function (a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    };
    StrategyBasedIndicator.prototype.um = function (a, b) {
        var c = _super.prototype.um.call(this, a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.y5(this.y4());
        c.shortPeriod = this.y5(this.y6());
        c.longPeriod = this.y5(this.y3());
        c.multiplier = this.y2();
        return c;
    };
    StrategyBasedIndicator.prototype.y2 = function () {
        return 1;
    };
    StrategyBasedIndicator.zf = function (a, b) {
        var c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, function (d, e) { return (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
        StrategyBasedIndicator.y1.add("Multiplier");
        return c;
    };
    StrategyBasedIndicator.prototype.o8 = function (a, b, c, d) {
        _super.prototype.o8.call(this, a, b, c, d);
        if (StrategyBasedIndicator.y1.contains(b)) {
            if (this.uv != null && !this.uv.c1()) {
                this.uq.b0.e(this.hj);
                this.x7(0, this.indicatorColumn.count);
                if (this.x4.ca) {
                    this.x4.b8.g$i();
                }
                this.pp(false);
            }
        }
    };
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    StrategyBasedIndicator.y1 = new List$1(String_$type, 0);
    return StrategyBasedIndicator;
}(FinancialIndicator));
export { StrategyBasedIndicator };
